<!-- Revision History (26072007) -->
<% 

Dim g_strEmailSettingsPageName
Dim g_strSaveOperation

'--------------------------------------------------------------------------------------------------------
Function EmailSettingsPageStartUp()

	g_strEmailSettingsPageName = "Settings" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Email Settings</span>"

	g_strSaveOperation = Request.QueryString("save_operation")
	
	'save the data to database if it was a successful save operation
	if (g_strSaveOperation = SAVE_OPERATION_SUCCESSFUL) then
		SaveEmailSettingsToDb()
	end if
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SaveEmailSettingsToDb()

	Dim strArrFormVariables
	Dim iArrSplitControl
	Dim iCounter
	
	Dim strDbFieldName
	Dim iUpdateValue
	Dim iRecordID
	
	'get all posted form variables and split them based on the '&' delimiter
	strArrFormVariables = Split(Request.Form, "&")
	
	For iCounter = 0 To UBound(strArrFormVariables)-2
		
		'the values sent via form varialbes need to be split apart further.
		iArrSplitControl = Split(strArrFormVariables(iCounter), "=")
	
		iRecordID = CInt(iArrSplitControl(0))
		iUpdateValue = URLDecode(iArrSplitControl(1))
		
		Call UpdateEmailSettings(iRecordID, iUpdateValue)
		
	Next

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateEmailSettings(strInputRecordID, iInputUpdateValue)
	
	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE [tbl_system_configuration] SET setting_value = '" & iInputUpdateValue & "' " & _
						    "WHERE [id_system_configuration] = " & strInputRecordID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawEmailSystemDropListHTML()

	%>
	<tr>
		<td class="item_list_table" colspan="2"><br><b>Email System</b> <span class="note">(Advanced)</span></td>
	</tr>
	<tr>
		<td align="right" class="item_list_table" style="padding-right: 10px; padding-top: 7px;" valign="top">Send Via:</td>
		<td align="left" class="item_list_table">
		<select size="1" id="existing_project_drop_list" class="control_drop_list_medium" name="drp_existing_project" onchange="ResetDropList('existing_project_drop_list', 'existing_project_validation_msg');">
			<option value="0">(Select Project)</option>
			
		</select>
		</td>
	</tr>		
	<%

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawEmailSettingsHTML()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strCurrentGroupName
	Dim strPreviousGroupName
	
	%><form method="post" action="<%= g_strPageName %>?save_operation=<%= SAVE_OPERATION_SUCCESSFUL %>" name="frm_email_settings" id="email_settings_form"  style="display:inline;"><% 
	
	
	
	strSqlQuery = "SELECT * FROM tbl_system_configuration " & _
								"WHERE (is_visible_on_front_end = 1) " & _ 
								"AND (has_been_deleted = 0) " & _
								"AND (id_belongs_to_group IN (73, 89, 90) ) " & _								
								"ORDER BY id_belongs_to_group, display_order;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF

		strCurrentGroupName = GetSettingGroupName(objRecordSet("id_belongs_to_group"))
		if (NOT strPreviousGroupName = strCurrentGroupName) then
		%>
		<tr>
			<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div><%= strCurrentGroupName %></td>
		</tr>			
		
		<%  
		end if
		
		%>
		<tr>
			<td align="right" class="item_list_table" style="padding-right: 10px; padding-top: 7px;" valign="top"><%= objRecordSet("setting_name") %>:</td>
			<td align="left" class="item_list_table"><%= GetHtmlControlType(objRecordSet("id_system_configuration"), objRecordSet("setting_name"), objRecordSet("setting_value"), objRecordSet("expected_value_size")) %></td>
		</tr>		
		<%
		objRecordSet.MoveNext
		strPreviousGroupName = strCurrentGroupName
		
	Loop
	
	'put in the submit and cancel buttons
	%>
	<tr>
		<td></td>
		<td align="left" colspan="2" style="padding-top: 8px;">
		
		<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="document.getElementById('email_settings_form').submit();">Save</a></div>
		<a href="<%= g_strPageName %>?save_operation=0" class="image_button"" style="margin: 5px 0 0 7px; float: left;">Cancel</a>

		</td>
	</tr>
	</form>
	<%
				
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawEmailSettingsHeaderHTML()

  %>
	<table>
	
	<tr>
		<td colspan="4"><%= DrawSaveSuccessfulHTML(g_strSaveOperation) %></td>
	</tr>
	
		<% if (g_strSettingEmailSendingIsEnabled = STR_FALSE) then %>
		
		<div class="validation_warning_msg">
		<b>Email sending is turned off at the moment.</b> This means notifications wont be sent when the owner of a bug changes or when a new account is created. 
		To turn on email sending, tick 'Enable email sending' below and configure your mail settings.	
		Technical note: please make sure your web server at least supports the 'CDOSYS' mail object; otherwise an error will occur when the system goes to send emails.
		</div>
		
		<% end if %>

	<tr>
		<td class="heading_bug_list" colspan="4"><%= g_strEmailSettingsPageName %></td>
	</tr>

	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawEmailSettingsFooterHTML()
	
	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function GetSettingDropListHTML(iInputSysConfigID, strInputSettingValue)

	const SETTING_GROUP = 0
	const SETTING_VALUE = 1

	Dim strRtnValue
	Dim strDropListOptions
	Dim strArrSettingValue
	
	Dim objRecordSet
	Dim strSqlQuery
		
	strArrSettingValue = Split(strInputSettingValue,",")
		
	strSqlQuery = "SELECT tbl_one_to_one_mapping_items.[id_item], tbl_one_to_one_mapping_items.item_name " & _
								"FROM tbl_one_to_one_mapping_items " & _
								"WHERE (((tbl_one_to_one_mapping_items.id_belongs_to_group) = " & strArrSettingValue(SETTING_GROUP) & "));"

	Set objRecordSet = GetRecordSet(strSqlQuery)
			
	Do Until objRecordSet.EOF
		strDropListOptions = strDropListOptions & "<option " & IsSelected(objRecordSet("id_item"), strArrSettingValue(SETTING_VALUE)) & " value=""" & strArrSettingValue(SETTING_GROUP) & "," & objRecordSet("id_item") & """>" & objRecordSet("item_name") & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
	
	strRtnValue = "<select size=""1"" name=""" & iInputSysConfigID & """ class=""ctrl_drop_list ctrl_drop_list_medium"">" & vbCrLf & _
								strDropListOptions & vbCrLf & _
								"</select>" & vbCrLf
	
	GetSettingDropListHTML = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
%>