<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3c.org/TR/1999/REC-html401-19991224/loose.dtd">
<HTML xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">

<!--
BugWeb helps web development teams track and prioritise bugs and feature requests.

Copyright (C) 2008  KLT Consulting

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
-->

<!--#include file="security_system.inc"-->
<!--#include file="db_connection.asp"-->
<!--#include file="global_constants.inc"-->
<!--#include file="global_constants_images.inc"-->
<!--#include file="global_custom_functions.inc"-->
<!--#include file="..\standard_components\global_common_functions.inc"-->
<!--#include file="global_system_logic.inc"-->
<!--#include file="primary_navigation.inc"-->
<!--#include file="email_engine.inc"-->

<HEAD>
	<TITLE><%= APP_NAME & ": " & FriendlyFileName(GetPageName()) %> (<%= g_strActiveProjectName %>)</TITLE>

	<meta http-equiv="X-UA-Compatible" content="IE=9" />
	<META http-equiv=content-type content="text/html; charset=iso-8859-1">
	<META name=author content="<%= METATAG_AUTHOR %>">
	<META name=keywords content="<%= METATAG_KEYWORDS %>">
	<META name=description content="<%= METATAG_DESCRIPTION %>">
	<META name=robots content=all>
	<META content="MSHTML 6.00.2900.2180" name=GENERATOR>

	<link rel="shortcut icon" href="favicon.ico" >
	<link rel="stylesheet" type="text/css" href="css/bugweb.css">

	<script language="JavaScript" src="javascript/jquery.js"></script>

	<script type="text/javascript" src="javascript/vtip.js"></script>
	<link rel="stylesheet" type="text/css" href="css/vtip.css" />
	
	<script language="JavaScript" src="javascript/overlib.js"></script>
	<script language="JavaScript" src="ajax_update_bug.js"></script>
	<script language="JavaScript" src="javascript/bugweb.js"></script>	

	<script language=""JavaScript"">
	
	//this only gets used with file custome-styled file upload controls
	var W3CDOM = (document.createElement && document.getElementsByTagName);
	
	function init() {
		if (!W3CDOM) return;
		
		var fakeFileUpload = document.createElement('div');
		fakeFileUpload.className = 'fakefile';
		fakeFileUpload.appendChild(document.createElement('input'));
		
		var image = document.createElement('img');
		image.src='images_layout/btn_browse.gif';
		image.style.verticalAlign='middle';
		image.style.paddingBottom = '0px';
		image.style.paddingLeft = '4px';
		image.style.cursor = 'pointer';		
		
		fakeFileUpload.appendChild(image);
		
		var x = document.getElementsByTagName('input');
		
		for (var i=0;i<x.length;i++) {
			if (x[i].type != 'file') continue;
			if (x[i].getAttribute('noscript')) continue;
			if (x[i].parentNode.className != 'fileinputs') continue;
			x[i].className = 'file hidden';
			var clone = fakeFileUpload.cloneNode(true);
			x[i].parentNode.appendChild(clone);
			x[i].relatedElement = clone.getElementsByTagName('input')[0];
			if (x[i].value)
				x[i].onchange();
			x[i].onchange = x[i].onmouseout = function () {
				this.relatedElement.value = this.value;
			}
		}
	}

	function createCookie(name,value,days) 
	{

		if (days) 
		{
			var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
			var expires = "; expires="+date.toGMTString();
		}
		else var expires = "";
		document.cookie = name+"="+value+expires+"; path=/";
	}
	
	function readCookie(name) 
	{
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
		}
		return null;
	}
	
	function eraseCookie(name) 
	{
		createCookie(name,"",-1);
	}

	</script>

	<style>
	
	body {
	  font-family: Verdana;
  	font-size: 11px;
  	color: #343434;
		margin: 0;
		<% 
		if (NOT Trim(g_strSettingBkgWatermark) = "") then
		 response.write "background: url('" & g_strSettingBkgWatermark & "');" & vbCrLf
		end if 
		%>
		background-position: right bottom;
		background-repeat: no-repeat;
	}
	
	</style>
	
</HEAD>

<body onload="init();">

	
<table width="100%">
<tr>
	<td align="center">

<table width="900">
<tr>
	<td colspan="2" align="left">
	

<table width="100%">
<tr>
	<td width="100%" colspan="2">&nbsp;</td>
</tr>
<tr>
	<td height="30" class="navigation_zone" width="20%">
	<%
	'do an access level check to see if user is allowed to log bugs (hide the log bugs button if theyre not allowed).
	if (g_iAccessPrivLogBugsButton = INT_TRUE) then
		%>
		<div class="ctrl_button button_float button_spacer_right"><a href="log_bug.asp">Log Bug</a></div>
		<%= GetPopupHelpDB(15, OVERLIB_X_POS) %>
		<%
	else
		%><div class="ctrl_button_small_disabled" title="Disabled">Log Bug</div><%
	end if 
	%>
	</td>
	<td class="navigation_zone" width="80%" align="right"><div class="nav_links"><% DrawPrimaryNavigationHTML() %></div></td>
</tr>
</table>