<!-- My Profile (10072007) -->
<% 


Dim g_strSaveOperation
Dim g_strPageMode
Dim g_strMyProfilePageName

Dim g_rsMyProfile

'--------------------------------------------------------------------------------------------------------
Function MyProfilePageStartUp()

	g_strPageMode = Request.QueryString("mode")
	g_strSaveOperation = Request.QueryString("save_operation")
	
	SetMyProfilePageMode()

	GetMyProfileDetails(g_iUserID)
	
End Function

'--------------------------------------------------------------------------------------------------------
Function DrawMyProfileHeaderHTML()

  %>
	<table>
	<tr>
		<td colspan="4"><% DrawSaveSuccessfulHTML(g_strSaveOperation) %>&nbsp;</td>
	</tr>
		
	<tr>
		<td class="heading_bug_list" colspan="4"><%= g_strMyProfilePageName %></td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawMyProfileHTML()

	%>
	<form method="post" id="my_profile_form" action="<%= g_strPageName %>?save_operation=1&mode=<%= MY_PROFILE_PAGE_MODE_UPDATE %>" name="frm_my_profile" style="display:inline;">

	<tr>
		<td class="table_sub_headling" colspan="2"><div class="section_divider"></div>Login Details</td>
	</tr>		
	
	<tr>
		<td class="table_label">Username:</td>
		<td><input type="text" id="username_textbox" onkeydown="ResetTextboxBackground('username_textbox');" name="txt_username" value="<%= g_rsMyProfile("login_username") %>" maxlength="32" class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %></td>
	</tr>
	<tr>
		<td class="table_label">Password:</td>
		<td><input type="text" id="password_textbox" onkeydown="ResetTextboxBackground('password_textbox');" name="txt_password" value="<%= g_rsMyProfile("user_password") %>" maxlength="16" class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %></td>
	</tr>

	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Your Information</td>
	</tr>		
	
	<tr>
		<td class="table_label">First name:</td>
		<td><input type="text" id="firstname_textbox" onkeydown="ResetTextboxBackground('firstname_textbox');" name="txt_first_name" value="<%= g_rsMyProfile("first_name") %>" maxlength="32" class="ctrl_textbox ctrl_textbox_medium"><%= ICON_REQUIRED_FIELD %></td>
	</tr>
	<tr>
		<td class="table_label">Surname:</td>
		<td><input type="text" name="txt_last_name" value="<%= g_rsMyProfile("last_name") %>" maxlength="32" class="ctrl_textbox ctrl_textbox_medium"></td>
	</tr>	
	<tr>
		<td class="table_label">Initials:</td>
		<td><input type="text"  id="initials_textbox" onkeydown="ResetTextboxBackground('initials_textbox');" name="txt_initials" value="<%= g_rsMyProfile("initials") %>" maxlength="3" class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %></td>
	</tr>
	<tr>
		<td class="table_label">Email address:</td>
		<td><input type="text" name="txt_email" value="<%= g_rsMyProfile("email_address") %>" maxlength="128" class="ctrl_textbox ctrl_textbox_medium">
		<%= GetPopupHelpDB(22, OVERLIB_X_POS) %></td>
	</tr>
	
	<tr>
		<td class="table_label">Company:</td>
		<td><input type="text" name="txt_company" value="<%= g_rsMyProfile("company") %>" maxlength="255" class="ctrl_textbox ctrl_textbox_medium"></td>
	</tr>	
	
	<tr>
		<td class="table_label">Instant messenger:</td>
		<td>
		<input type="text" name="txt_instant_messenger"" value="<%= g_rsMyProfile("instant_messenger") %>"  maxlength="255" class="ctrl_textbox ctrl_float" style="width: 190px; margin: 3px 5px 0 0;">
		<select size="1" id="im_type_drop_list" name="drp_im_type" class="ctrl_drop_list ctrl_float"  style="width: 93px;">
			<%= GetIMClientNames(g_rsMyProfile("id_im_type")) %>
		</select>
		</td>
	</tr>		
	
	
	<!-- *** FEATURE ON-HOLD, FOR FUTURE IMPLEMENTATION ***
	<tr>
		<td class="item_list_table" style="padding-right: 10px; " align="right">Login IP Address:</td>
		<td class="item_list_table"><input type="text" name="txt_login_ip_address" value="<%= g_rsMyProfile("login_ip_address") %>" size="20" maxlength="128" class="control_textbox_medium"></td>
	</tr>		
	-->

	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Account Options</td>
	</tr>			
	
	<tr>
		<td class="table_label">Interface style:</td>
		<td class="table_label_right">
		<input type="radio" value="<%= UI_STYLE_BASIC %>" <%= IsChecked(g_rsMyProfile("interface_style"), UI_STYLE_BASIC) %>  name="rdo_interface_style" class="form_control_radio_button"><span class="form_control_radio_button_text">Basic</span>
		<input type="radio" value="<%= UI_STYLE_STANDARD %>" <%= IsChecked(g_rsMyProfile("interface_style"), UI_STYLE_STANDARD) %>  name="rdo_interface_style" class="form_control_radio_button"><span class="form_control_radio_button_text">Standard</span>
		<%= GetPopupHelpDB(3, OVERLIB_X_POS) %>
		</td>
	</tr>		
	
	<tr>
		<td class="table_label">Pop-up help:</td>
		<td class="table_label_right">
		<input type="radio" value="<%= POP_UP_HELP_NONE %>" <%= IsChecked(g_rsMyProfile("popup_help"), POP_UP_HELP_NONE) %>  name="rdo_popup_help" class="form_control_radio_button"><span class="form_control_radio_button_text">None</span>
		<input type="radio" value="<%= POP_UP_HELP_ADVANCED_ONLY %>" <%= IsChecked(g_rsMyProfile("popup_help"), POP_UP_HELP_ADVANCED_ONLY) %>  name="rdo_popup_help" class="form_control_radio_button"><span class="form_control_radio_button_text">Advanced only</span>
		<input type="radio" value="<%= POP_UP_HELP_ALL %>" <%= IsChecked(g_rsMyProfile("popup_help"), POP_UP_HELP_ALL) %>  name="rdo_popup_help" class="form_control_radio_button"><span class="form_control_radio_button_text">All</span>		
		<%= GetPopupHelpDB(13, OVERLIB_X_POS) %>
		</td>
	</tr>		
	
	<tr>
		<td class="table_label">After logging a bug:</td>
		<td class="table_label_right">
		<input type="radio" value="<%= AFTER_LOGGING_BUG_LOG_BUG %>" <%= IsChecked(g_rsMyProfile("action_after_logging_bug"), AFTER_LOGGING_BUG_LOG_BUG) %>  name="rdo_action_after_logging_bug" class="form_control_radio_button"><span class="form_control_radio_button_text">Stay on log bug page</span>
		<input type="radio" value="<%= AFTER_LOGGING_BUG_GO_HOME %>" <%= IsChecked(g_rsMyProfile("action_after_logging_bug"), AFTER_LOGGING_BUG_GO_HOME) %>  name="rdo_action_after_logging_bug" class="form_control_radio_button"><span class="form_control_radio_button_text">Go to home page</span>
		<%= GetPopupHelpDB(34, OVERLIB_X_POS) %>
		</td>
	</tr>		

	<!-- 	
	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="<%= g_rsMyProfile("is_first_login") %>" class="control_checkbox_alt_02" <%= SetCheckBox(g_rsMyProfile("is_first_login")) %> name="chk_first_login"><span class="checkbox_text">Offer video tutorials on first login</span> <%= GetPopupHelpDB(4, OVERLIB_X_POS) %></td>
	</tr>
	-->	

	<!-- removed as it was a fall-safe for a bug which is now fixed
	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="<%= g_rsMyProfile("use_add_comment_safe_mode") %>" class="control_checkbox_alt_02" <%= SetCheckBox(g_rsMyProfile("use_add_comment_safe_mode")) %> name="chk_use_add_comment_safe_mode"><span class="checkbox_text">Use 'add comment' safe mode</span> <%= GetPopupHelpDB(29, OVERLIB_X_POS) %></td>
	</tr>	
	-->
	
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Email Notification</td>
	</tr>
	<tr>
		<td class="table_sub_headling" colspan="2"><% ShowEmailSendingStatusMsg() %></td>
	</tr>							
	
	<tr>
		<td class="table_label">&nbsp;</td>
		<td><input type="checkbox" value="<%= g_rsMyProfile("email_when_new_bug_is_logged") %>" class="control_checkbox_alt_02" <%= SetCheckBox(g_rsMyProfile("email_when_new_bug_is_logged")) %> name="chk_email_when_new_bug_is_logged"><span class="checkbox_text">When a new bug is logged</span> <%= GetPopupHelpDB(8, OVERLIB_X_POS) %></td>
	</tr>	
	<tr>
		<td class="table_label">&nbsp;</td>
		<td><input type="checkbox" value="<%= g_rsMyProfile("email_when_bug_is_updated") %>" class="control_checkbox_alt_02" <%= SetCheckBox(g_rsMyProfile("email_when_bug_is_updated")) %> name="chk_email_when_bug_is_updated"><span class="checkbox_text">When a bug is updated</span> <%= GetPopupHelpDB(11, OVERLIB_X_POS) %></td>
	</tr>	
	<tr>
		<td class="table_label">&nbsp;</td>
		<td><input type="checkbox" value="<%= g_rsMyProfile("email_when_comment_is_added") %>" class="control_checkbox_alt_02" <%= SetCheckBox(g_rsMyProfile("email_when_comment_is_added")) %> name="chk_email_when_comment_is_added"><span class="checkbox_text">When a comment is added against a bug</span> <%= GetPopupHelpDB(31, OVERLIB_X_POS) %></td>
	</tr>	
	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="<%= g_rsMyProfile("limit_emails_per_day") %>" class="control_checkbox_alt_02" <%= SetCheckBox(g_rsMyProfile("limit_emails_per_day")) %> name="chk_limit_emails_per_day"><span class="checkbox_text">Limit emails per day <span class="note">(max. <%= MAX_EMAIL_NOTIFICATIONS_PER_DAY %> bug notifications)</span></span> <%= GetPopupHelpDB(12, OVERLIB_X_POS) %></td>
	</tr>	
	
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Access to Projects</td>
	</tr>
	
	
	<tr>
		<td class="table_label">&nbsp;</td>
		<td><%= GetProjectAssociations() %></td>
	</tr>		

	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Account Information</td>
	</tr>	
	
	<tr>
		<td class="table_label">Account Type:</td>
		<td class="table_label_right"><%= g_rsMyProfile("account_type_name") %>&nbsp;<%= GetPopupHelpDB(24, OVERLIB_X_POS) %></td>
	</tr>		
	<tr>
		<td class="table_label">Independent QA:</td>
		<td class="table_label_right"><%= IntToYesNo(g_rsMyProfile("is_independent_qa")) %>&nbsp;<%= GetPopupHelpDB(14, OVERLIB_X_POS) %></td>
	</tr>		
	<tr>
		<td class="table_label">Must leave a time estimate:</td>
		<td class="table_label_right"><%= IntToYesNo(g_rsMyProfile("must_leave_time_estimate")) %>&nbsp;<%= GetPopupHelpDB(30, OVERLIB_X_POS) %></td>
	</tr>		
	<tr>
		<td class="table_label">Account expires:</td>
		<td class="table_label_right"><%= CompactDate(g_rsMyProfile("login_expiration_date")) %></td>
	</tr>
	
	<!-- *** FEATURE ON-HOLD, FOR FUTURE IMPLEMENTATION ***
	<tr>
		<td class="item_list_table" style="padding-right: 10px;" align="right">IP-based Login:</td>
		<td class="item_list_table" align="left"><%= IntToStatus(g_rsMyProfile("ip_based_login_allowed")) %></td>
	</tr>
	--> 
	<!-- redunantant information. a disabled accont would never see this.
	<tr>
		<td class="item_list_table" style="padding-right: 10px;" align="right">Account Status:</td>
		<td class="item_list_table" align="left"><%= IntToStatus(g_rsMyProfile("account_is_active")) %></td>
	</tr>		
	-->
	
	<tr>
		<td></td>
		<td colspan="2" style="padding-top: 15px;">

		<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateMyProfileForm(); return false;">Update</a></div>
		<a href="<%= g_strPageName %>?save_operation=0" class="image_button"" style="margin: 5px 0 0 7px; float: left;">Cancel</a>

		</td>
	</tr>
	</form>
	<%
		
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawMyProfileFooterHTML()
	
	%>
	</table>
	<%  
		
	g_rsMyProfile.Close
	Set g_rsMyProfile = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function GetMyProfileDetails(iInputUserID)

	Dim strSqlQuery
	
	strSqlQuery = "SELECT tbl_users.*, tbl_user_account_types.account_type_name " & _
								"FROM tbl_users INNER JOIN tbl_user_account_types ON tbl_users.id_user_account_type = tbl_user_account_types.id_user_account_type " & _
								"WHERE id_user = " & iInputUserID
		
	Set g_rsMyProfile = GetRecordSet(strSqlQuery)
	
End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateMyProfileDetailsToDb(iInputUserID)

	Dim strSqlQuery
	Dim objRecordSet
	Dim iFirstLogin
	
	Dim iEmailWhenNewBugIsLogged
	Dim iEmailWhenBugIsUpdated
	Dim iEmailWhenCommentIsAdded
	Dim iLimitEmailsPerDay
	
	Dim iUseAddCommentSafeMode

	iFirstLogin = CheckboxToIntBool(Request.Form("chk_first_login"))
	iUseAddCommentSafeMode = CheckboxToIntBool(Request.Form("chk_use_add_comment_safe_mode"))
	
	iEmailWhenNewBugIsLogged = CheckboxToIntBool(Request.Form("chk_email_when_new_bug_is_logged"))
	iEmailWhenBugIsUpdated = CheckboxToIntBool(Request.Form("chk_email_when_bug_is_updated"))
	iEmailWhenCommentIsAdded = CheckboxToIntBool(Request.Form("chk_email_when_comment_is_added"))
	iLimitEmailsPerDay = CheckboxToIntBool(Request.Form("chk_limit_emails_per_day"))
	
	strSqlQuery = "UPDATE tbl_users SET " & _
								"login_username = '" & MakeTextDBSafeUpdate(Request.Form("txt_username")) & "', " & _
								"user_password = '" & MakeTextDBSafeUpdate(Request.Form("txt_password")) & "', " & _
								"first_name = '" & MakeTextDBSafeUpdate(Request.Form("txt_first_name")) & "', " & _
								"last_name = '" & MakeTextDBSafeUpdate(Request.Form("txt_last_name")) & "', " & _
								"initials = '" & MakeTextDBSafeUpdate(Request.Form("txt_initials")) & "', " & _
								"email_address = '" & MakeTextDBSafeUpdate(Request.Form("txt_email")) & "', " & _
								"company = '" & MakeTextDBSafeUpdate(Request.Form("txt_company")) & "', " & _
								"instant_messenger = '" & MakeTextDBSafeUpdate(Request.Form("txt_instant_messenger")) & "', " & _
								"id_im_type = " & MakeTextDBSafeUpdate(Request.Form("drp_im_type")) & ", " & _																
								"login_ip_address = '" & MakeTextDBSafeUpdate(Request.Form("txt_login_ip_address")) & "', " & _
								"interface_style = " & Request.Form("rdo_interface_style") & ", " & _						
								"popup_help = " & Request.Form("rdo_popup_help") & ", " & _												
								"is_first_login = " & iFirstLogin & ", " & _		
								"email_when_new_bug_is_logged = " & iEmailWhenNewBugIsLogged & ", " & _
								"email_when_bug_is_updated = " & iEmailWhenBugIsUpdated & ", " & _
								"email_when_comment_is_added = " & iEmailWhenCommentIsAdded & ", " & _								
								"limit_emails_per_day = " & iLimitEmailsPerDay & ", " & _
								"action_after_logging_bug = " & Request.Form("rdo_action_after_logging_bug")  & " " & _								
								"WHERE id_user = " & iInputUserID

								
								
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function SetMyProfilePageMode()

	Select Case g_strPageMode

		Case MY_PROFILE_PAGE_MODE_UPDATE
			g_strMyProfilePageName = "My Profile"
			UpdateMyProfileDetailsToDb(g_iUserID)
		
		Case Else
			g_strMyProfilePageName = "My Profile"
	
	End Select

End Function
'--------------------------------------------------------------------------------------------------------
Function GetProjectAssociations()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT tbl_projects.project_name " & _
								"FROM tbl_user_to_project_mapping INNER JOIN tbl_projects ON tbl_user_to_project_mapping.id_project = tbl_projects.id_project " & _
								"WHERE id_user = " & g_iUserID & " ORDER BY project_name;"

	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		strRtnValue = strRtnValue & "&bull; " & objRecordSet("project_name")
		objRecordSet.MoveNext
		
		if (NOT objRecordSet.EOF) then
			strRtnValue =strRtnValue & "<br>"
		end if
		
	Loop
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
	GetProjectAssociations = strRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
%>