<!-- Revision History (26072007) -->
<% 

Dim g_strSystemConfigurationPageName
Dim g_strSaveOperation

'--------------------------------------------------------------------------------------------------------
Function SystemConfigurationPageStartUp()

	g_strSystemConfigurationPageName = "Settings" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">System Configuration</span>"

	g_strSaveOperation = Request.QueryString("save_operation")
	
	'save the data to database if it was a successful save operation
	if (g_strSaveOperation = SAVE_OPERATION_SUCCESSFUL) then
		SaveSystemConfigurationToDb()
	end if
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SaveSystemConfigurationToDb()

	Dim strArrFormVariables
	Dim iArrSplitControl
	Dim iCounter
	
	Dim strDbFieldName
	Dim iUpdateValue
	Dim iRecordID
	
	'get all posted form variables and split them based on the '&' delimiter
	strArrFormVariables = Split(Request.Form, "&")
	
	For iCounter = 0 To UBound(strArrFormVariables)-2
		
		'the values sent via form varialbes need to be split apart further.
		iArrSplitControl = Split(strArrFormVariables(iCounter), "=")
	
		iRecordID = CInt(iArrSplitControl(0))
		iUpdateValue = URLDecode(iArrSplitControl(1))
		
		Call UpdateSystemConfiguration(iRecordID, iUpdateValue)
		
	Next

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateSystemConfiguration(strInputRecordID, iInputUpdateValue)
	
	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE [tbl_system_configuration] SET setting_value = '" & iInputUpdateValue & "' " & _
						    "WHERE [id_system_configuration] = " & strInputRecordID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSystemConfigurationHTML()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strCurrentGroupName
	Dim strPreviousGroupName
	
	%><form method="post" action="<%= g_strPageName %>?save_operation=<%= SAVE_OPERATION_SUCCESSFUL %>" name="frm_system_configuration" id="frm_system_configuration" style="display:inline;"><% 
	
	strSqlQuery = "SELECT * FROM tbl_system_configuration " & _
								"WHERE (is_visible_on_front_end = 1) " & _ 
								"AND (has_been_deleted = 0) " & _
								"AND (id_belongs_to_group IN (71, 88, 87) ) " & _								
								"ORDER BY id_belongs_to_group, display_order;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF

		strCurrentGroupName = GetSettingGroupName(objRecordSet("id_belongs_to_group"))
		if (NOT strPreviousGroupName = strCurrentGroupName) then
		%>
		<tr>
			<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div><%= strCurrentGroupName %></td>
		</tr>				
		<%  
		end if
		
		%>
		<tr>
			<td class="table_label"><%= objRecordSet("setting_name") %>:</td>
			<td><%= GetHtmlControlType(objRecordSet("id_system_configuration"), objRecordSet("setting_name"), objRecordSet("setting_value"), objRecordSet("expected_value_size")) %></td>
		</tr>		
		<%
		objRecordSet.MoveNext
		strPreviousGroupName = strCurrentGroupName
		
	Loop
	
	'put in the submit and cancel buttons
	%>
	<tr>
		<td></td>
		<td colspan="2" style="padding-top: 8px;">
		
		<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="document.getElementById('frm_system_configuration').submit();">Save</a></div>
		<a href="<%= g_strPageName %>?save_operation=0" class="image_button"" style="margin: 5px 0 0 7px; float: left;">Cancel</a>

		</td>
	</tr>
	</form>
	<%
				
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSystemConfigurationHeaderHTML()

  %>
	<table>
	<tr>
		<td colspan="4"><%= DrawSaveSuccessfulHTML(g_strSaveOperation) %></td>
	</tr>	
	<tr>
		<td class="heading_bug_list" colspan="4" align="left"><%= g_strSystemConfigurationPageName %></td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSystemConfigurationFooterHTML()
	
	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
%>