<!-- Users (20072007) -->
<% 
const USERS_PAGE_MODE_EDIT = "1"
const USERS_PAGE_MODE_READY_FOR_NEW = "2"
const USERS_PAGE_MODE_SOFT_DELETE = "3"
const USERS_PAGE_MODE_UPDATE = "4"
const USERS_PAGE_MODE_INSERT = "5"

Dim g_strSaveOperation
Dim g_strPageMode
Dim g_strEditUserID

Dim g_iSettingsUserID
Dim g_iAccountTypeID
Dim g_iAccountIsActive

Dim g_strLoginUsername
Dim g_strUserPassword
Dim g_strFirstName

Dim g_strLastName
Dim g_strInitials
Dim g_strLoginExpirationDate

Dim g_strEmailAddress
Dim g_iIpBasedLoginAllowed
Dim g_iIsIndependentQA

Dim g_strLoginIpAddress
Dim g_iInterfaceStyle
Dim g_iIsFirstLogin

Dim g_iNewlyAddedUserID
Dim g_strUserPageName
Dim g_iPopupHelp

Dim g_iEmailWhenNewBugIsLogged
Dim g_iEmailWhenBugIsClosed
Dim g_iEmailWhenBugIsAssignedToMe

Dim g_iEmailWhenBugIsUpdated
Dim g_iEmailWhenCommentIsAdded
Dim g_iLimitEmailsPerDay

Dim g_strCompany
Dim g_InstantMessenger
Dim g_iIMTypeID 

Dim g_iUseAddCommentSafeMode
Dim g_iMustLeaveTimeEstimate
Dim g_UserToProjectLinkageCheckJavascript

Dim g_iCanBeDeleted
Dim g_iActionAfterLoggingBug

'--------------------------------------------------------------------------------------------------------
Function UserPageStartUp()

	g_strPageMode = Request.Form("hid_mode")

	if (NOT Request.QueryString("mode") = "") then
		g_strPageMode = Request.QueryString("mode")
	end if	
	
	g_strSaveOperation = Request.QueryString("save_operation")
	g_strEditUserID = Request.Form("drp_existing_user")
	
	'set default values
	g_iInterfaceStyle = UI_STYLE_STANDARD
	g_iPopupHelp = POP_UP_HELP_ALL
	g_iEmailWhenNewBugIsLogged = INT_TRUE
	g_iEmailWhenBugIsUpdated = INT_TRUE
	g_iEmailWhenCommentIsAdded = INT_TRUE
	g_iActionAfterLoggingBug = AFTER_LOGGING_BUG_LOG_BUG

End Function
'--------------------------------------------------------------------------------------------------------
Function SaveNewUserToDb()

	Dim strSqlQuery
	Dim objRecordSet

	Dim strLoginExpirationDate
	
	strLoginExpirationDate = Request.Form("drp_day") & Request.Form("drp_month") & Request.Form("drp_year") 
	
	strSqlQuery = "INSERT INTO tbl_users " & _
								"(id_user_account_type, account_is_active, login_username, user_password, first_name, last_name, initials, " & _
								"login_expiration_date, email_address, company, instant_messenger, id_im_type, is_independent_qa, interface_style, popup_help, is_first_login, " & _
								"must_leave_time_estimate, email_when_new_bug_is_logged, email_when_bug_is_updated, email_when_comment_is_added, limit_emails_per_day, action_after_logging_bug) " & _
								"VALUES " & _
								"(" & _
								CInt(Request.Form("drp_account_type")) & ", " & _
								CheckboxToInt(Request.Form("chk_account_is_active")) & ", '" & _										 
								DBSafe(Request.Form("txt_login_username")) & "', '" & _
								DBSafe(Request.Form("txt_user_password")) & "', '" & _
								DBSafe(Request.Form("txt_first_name")) & "', '" & _
								DBSafe(Request.Form("txt_last_name")) & "', '" & _										 
								DBSafe(Request.Form("txt_initials")) & "', '" & _
								strLoginExpirationDate & "', '" & _
								DBSafe(Request.Form("txt_email_address")) & "', '" & _
								DBSafe(Request.Form("txt_company")) & "', '" & _
								DBSafe(Request.Form("txt_instant_messenger")) & "', " & _								
								Request.Form("drp_im_type") & ", " & _								
								CheckboxToInt(Request.Form("chk_is_independent_qa")) & ", " & _
								Request.Form("rdo_interface_style") & ", " & _
								Request.Form("rdo_popup_help") & ", " & _
								CheckboxToInt(Request.Form("chk_is_first_login")) & ", " & _						
								CheckboxToInt(Request.Form("chk_must_leave_time_estimate")) & ", " & _					
								CheckboxToInt(Request.Form("chk_email_when_new_bug_is_logged")) & ", " & _	
								CheckboxToInt(Request.Form("chk_email_when_bug_is_updated")) & ", " & _	
								CheckboxToInt(Request.Form("chk_email_when_comment_is_added")) & ", " & _									
								CheckboxToInt(Request.Form("chk_limit_emails_per_day")) & ", " & _			
								Request.Form("rdo_action_after_logging_bug") & _ 
								");"

	'debugX strSqlQuery
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

	g_iNewlyAddedUserID = GetNewlyAddedRecordID()

End Function
'--------------------------------------------------------------------------------------------------------
Function GetUserDetails(iInputUserID)

	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT * FROM tbl_users WHERE id_user	 = " & iInputUserID
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	if (NOT objRecordSet.EOF) then
		g_iSettingsUserID = objRecordSet("id_user")
		g_iAccountTypeID = objRecordSet("id_user_account_type")
		g_iAccountIsActive = objRecordSet("account_is_active")
		g_strLoginUsername = objRecordSet("login_username")
		g_strUserPassword = objRecordSet("user_password")
		g_strFirstName = objRecordSet("first_name")
		g_strLastName = objRecordSet("last_name")
		g_strInitials = objRecordSet("initials")
		g_strLoginExpirationDate = objRecordSet("login_expiration_date")
		g_strEmailAddress = objRecordSet("email_address")
		g_iIpBasedLoginAllowed = objRecordSet("ip_based_login_allowed")
		g_iIsIndependentQA = objRecordSet("is_independent_qa")
		g_strLoginIpAddress = objRecordSet("login_ip_address")
		g_iInterfaceStyle = objRecordSet("interface_style")
		g_iIsFirstLogin = objRecordSet("is_first_login")	
		g_iEmailWhenNewBugIsLogged = objRecordSet("email_when_new_bug_is_logged")
		g_iEmailWhenBugIsUpdated = objRecordSet("email_when_bug_is_updated")
		g_iEmailWhenCommentIsAdded = objRecordSet("email_when_comment_is_added")
		g_iLimitEmailsPerDay = objRecordSet("limit_emails_per_day")
		g_iPopupHelp = objRecordSet("popup_help")
		g_strCompany = objRecordSet("company")
		g_InstantMessenger = objRecordSet("instant_messenger")
		g_iIMTypeID = objRecordSet("id_im_type") 
		g_iMustLeaveTimeEstimate = objRecordSet("must_leave_time_estimate") 
		g_iCanBeDeleted = objRecordSet("can_be_deleted") 
		g_iActionAfterLoggingBug = objRecordSet("action_after_logging_bug") 
	end if


	objRecordSet.Close
	Set objRecordSet = Nothing
	
End Function
'--------------------------------------------------------------------------------------------------------
Function SoftDeleteUser(strInputUserID)

	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "UPDATE tbl_users SET has_been_deleted = 1 WHERE id_user = " & strInputUserID
	
	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function UpdateUserDetailsToDb()

	Dim strSqlQuery
	Dim objRecordSet

	Dim strLoginExpirationDate

	strLoginExpirationDate = Request.Form("drp_day") & Request.Form("drp_month") & Request.Form("drp_year") 
				
	strSqlQuery = "UPDATE tbl_users SET " & _
								"id_user_account_type = " & Request.Form("drp_account_type") & ", " & _
								"account_is_active = " & CheckboxToInt(Request.Form("chk_account_is_active")) & ", " & _
								"login_username = '" & DBSafe(Request.Form("txt_login_username")) & "', " & _
								"user_password = '" & DBSafe(Request.Form("txt_user_password")) & "', " & _
								"first_name = '" & DBSafe(Request.Form("txt_first_name")) & "', " & _
								"last_name = '" & DBSafe(Request.Form("txt_last_name")) & "', " & _
								"initials = '" & DBSafe(Request.Form("txt_initials")) & "', " & _
								"login_expiration_date = '" & strLoginExpirationDate & "', " & _
								"email_address = '" & DBSafe(Request.Form("txt_email_address")) & "', " & _
								"company = '" & DBSafe(Request.Form("txt_company")) & "', " & _
								"instant_messenger = '" & DBSafe(Request.Form("txt_instant_messenger")) & "', " & _
								"id_im_type = " & DBSafe(Request.Form("drp_im_type")) & ", " & _														
								"is_independent_qa = " & CheckboxToInt(Request.Form("chk_is_independent_qa")) & ", " & _
								"login_ip_address = '" & DBSafe(Request.Form("txt_login_ip_address")) & "', " & _
								"interface_style = " & Request.Form("rdo_interface_style") & ", " & _			
								"popup_help = " & Request.Form("rdo_popup_help") & ", " & _
								"is_first_login = " & CheckboxToInt(Request.Form("chk_is_first_login")) & ", " & _
								"must_leave_time_estimate = " & CheckboxToInt(Request.Form("chk_must_leave_time_estimate")) & ", " & _
								"email_when_new_bug_is_logged = " & CheckboxToIntBool(Request.Form("chk_email_when_new_bug_is_logged")) & ", " & _
								"email_when_bug_is_updated = " & CheckboxToIntBool(Request.Form("chk_email_when_bug_is_updated")) & ", " & _
								"email_when_comment_is_added = " & CheckboxToIntBool(Request.Form("chk_email_when_comment_is_added")) & ", " & _								
								"limit_emails_per_day = " & CheckboxToIntBool(Request.Form("chk_limit_emails_per_day")) & ", " & _	
								"action_after_logging_bug = " & Request.Form("rdo_action_after_logging_bug") & " " & _
							  "WHERE id_user = " & Request.Form("hid_user_id")

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function SetUserPageMode()
	
	Select Case g_strPageMode

		Case USERS_PAGE_MODE_EDIT
			g_strUserPageName = "Users" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Edit Existing</span>"
			GetUserDetails(g_strEditUserID)	
		
		case USERS_PAGE_MODE_UPDATE
			g_strUserPageName = "Users" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Create New</span>"
			UpdateUserDetailsToDb()
			FlushProjectAssociations(Request.Form("hid_user_id"))
			SaveProjectAssociationsToDb(Request.Form("hid_user_id"))
		
		case USERS_PAGE_MODE_INSERT
			g_strUserPageName = "Users" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Create New</span>"
			SaveNewUserToDb()
			SaveProjectAssociationsToDb(g_iNewlyAddedUserID)
			SendNewUserLoginDetails()
		
		Case USERS_PAGE_MODE_SOFT_DELETE
			g_strUserPageName = "Users" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Create New</span>"
			SoftDeleteUser(Request.Form("hid_user_id"))
			FlushProjectAssociations(Request.Form("hid_user_id"))
		
		Case Else
			g_strUserPageName = "Users" & ARROW_SECTION_DIVIDER & "<span class=""page_sub_mode_heading"">Create New</span>"
	
	End Select

End Function
'--------------------------------------------------------------------------------------------------------
Function SendNewUserLoginDetails()

	Dim strEmailMessageBody
	Dim strEmailSubject
	Dim strEmailFromAddress
	
	Dim strEmailToAddress
	Dim strMessageToUser
	Dim strEmailRecipientFullName

	Dim strBkgColour
	Dim strHtmlHeader
	Dim strHtmlFooter
	
	if (g_strSettingEmailSendingIsEnabled = STR_FALSE) then
		Exit Function	
	end if

	strEmailFromAddress = g_strSettingBugWebFromAddress
	strEmailToAddress = DBSafe(Request.Form("txt_email_address"))
	strEmailSubject = "Welcome to BugWeb - your login details"
	strBkgColour = NEW_ACCOUNT_NOTICE_COLOUR_SCHEME
	strMessageToUser = "A <i>BugWeb</i> account has just been created for you. Your login details are:<br/><br/>"
	strEmailRecipientFullName = DBSafe(Request.Form("txt_first_name"))  & " " & DBSafe(Request.Form("txt_last_name"))
	
	strHtmlHeader = GetHtmlHeader(strEmailSubject)
	strHtmlFooter = GetHtmlFooter()
	
	
	strEmailMessageBody = strHtmlHeader & _
											CreateEmailSection("", "<b>ATT:</b> " & strEmailRecipientFullName & "<br/><br/>"  & strMessageToUser, strBkgColour) & _
											CreateEmailSection("Username", DBSafe(Request.Form("txt_login_username")), strBkgColour) & _
											CreateEmailSection("Password", DBSafe(Request.Form("txt_user_password")), strBkgColour) & _								
											CreateEmailSection("BugWeb URL", GetBugWebSystemURL(), strBkgColour) & _											
											CreateEmailSection("", "<br/>" & g_strSettingAdditionalMessageBody, strBkgColour) & _
											strHtmlFooter
											
	Call SendEmail(strEmailToAddress, strEmailFromAddress, strEmailSubject, strEmailMessageBody, _
								 g_strSettingDebugModeEnabled, g_strSettingSendEmailsVia, g_strArrSettingsSmtpServer)

End Function
'--------------------------------------------------------------------------------------------------------
Function FillExistingUsersDropList()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	Dim strUserName
	Dim strInactiveMarker
	
	strSqlQuery = "SELECT tbl_users.id_user, tbl_users.first_name, tbl_users.last_name, tbl_user_account_types.account_type_name, tbl_users.account_is_active " & _
								"FROM tbl_users INNER JOIN tbl_user_account_types ON tbl_users.id_user_account_type = tbl_user_account_types.id_user_account_type " & _
								"WHERE (has_been_deleted = 0) ORDER BY first_name;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF

		if (objRecordSet("account_is_active") = INT_FALSE) then
			strInactiveMarker	= " *Inactive*"
		else
			strInactiveMarker	= ""
		end if
	
		strUserName = objRecordSet("first_name") & " " & objRecordSet("last_name") & " (" & objRecordSet("account_type_name") & ")" & strInactiveMarker
		strRtnValue = strRtnValue & "<option " & IsSelected(objRecordSet("id_user"), g_strEditUserID) & " value=""" & objRecordSet("id_user") & """>" & strUserName & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	FillExistingUsersDropList = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function FillAccountTypeDropList(iInputSelectedOption)

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet
	
	'return a list of all users who arent clients (i.e. developers and admin).
	strSqlQuery = "SELECT id_user_account_type, account_type_name FROM tbl_user_account_types ORDER BY id_user_account_type;"
	
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		strRtnValue = strRtnValue & "<option " & IsSelected(iInputSelectedOption, objRecordSet("id_user_account_type")) & " value=""" & objRecordSet("id_user_account_type") & """>" & objRecordSet("account_type_name") & "</option>" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing
		
	FillAccountTypeDropList = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawBelongsToProjectList()

	Dim strRtnValue
	Dim strSqlQuery
	Dim objRecordSet

	Dim iArrCurrentProjectAssociations
	Dim iCounter
	
	'an existing user is being edited, therefore get their current project associations
	if (g_strPageMode = USERS_PAGE_MODE_EDIT) then
		iArrCurrentProjectAssociations = GetCurrentProjectAssociations(g_strEditUserID)
	else
		iArrCurrentProjectAssociations = 0
	end if
		
	strSqlQuery = "SELECT * FROM tbl_projects WHERE (has_been_deleted = 0) ORDER BY project_name;"
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF
		%>
		<tr>
			<td class="item_list_table" style="padding-right: 10px;" align="right"></td>
			<td class="item_list_table" align="left">
			<input type="checkbox" <%= CheckIfUserAssociatedWithProject(objRecordSet("id_project"), iArrCurrentProjectAssociations) %> value="<%= objRecordSet("id_project") %>" class="control_checkbox_alt_02" id="proj_id_checkbox_<%= objRecordSet("id_project") %>" name="chk_belongs_to_project_id_<%= objRecordSet("id_project") %>">
			<%= objRecordSet("project_name") %> <sup class="superscript_subtle"><%= objRecordSet("project_code") %></sup>
			</td>
		</tr>	
		<%  
		'this string gets used by the javascript validation on the page.
		g_UserToProjectLinkageCheckJavascript = g_UserToProjectLinkageCheckJavascript  & "if (document.getElementById('proj_id_checkbox_" & objRecordSet("id_project") & "').checked == true) { bRtnValue = true; } ;" & vbCrLf
		objRecordSet.MoveNext
	Loop
				
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function CheckIfUserAssociatedWithProject(iInputCurrentProjectID, iInputArrUserProjectAssociations)

	Dim strRtnValue
	Dim iCounter

	if (IsArray(iInputArrUserProjectAssociations) = false) then
		'its not edit mode, in which case, do nothing
		strRtnValue = ""
	else
		'cycle thru the users current project associations and check if they match the project id thats just been sent into this function
		For iCounter = 0 To UBound(iInputArrUserProjectAssociations)
		
			if ( iInputCurrentProjectID = iInputArrUserProjectAssociations(iCounter) ) then
				strRtnValue = " checked "
				Exit For
			end if
			
		Next
		
	end if
	
	CheckIfUserAssociatedWithProject = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function FlushProjectAssociations(iInputUserID)
	
	Dim strSqlQuery
	Dim objRecordSet
				
	strSqlQuery = "DELETE FROM tbl_user_to_project_mapping WHERE id_user = " & iInputUserID

	Set objRecordSet = g_objDbConn.Execute(strSqlQuery)

End Function
'--------------------------------------------------------------------------------------------------------
Function SaveProjectAssociationsToDb(iInputUserID)

	Dim strSqlQuery
	Dim objRecordSet
	
	Dim iProjectID
	Dim objInsertRecord
	Dim iSaveToUserID
	
	strSqlQuery = "SELECT id_project FROM tbl_projects WHERE has_been_deleted = 0 ORDER BY project_name;"
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	Do Until objRecordSet.EOF

		iProjectID = Request.Form("chk_belongs_to_project_id_" & objRecordSet("id_project"))
		
		'only insert the user-to-project relationship if the checkbox relating to the project has been checked.
		if (NOT iProjectID = "") then
		
			strSqlQuery = "INSERT INTO tbl_user_to_project_mapping (id_user, id_project) " & _
									  "VALUES (" & iInputUserID & ", " & iProjectID & ");"
		
			Set objInsertRecord = g_objDbConn.Execute(strSqlQuery)
			
		end if
		
		objRecordSet.MoveNext
		
	Loop
	
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawUsersHeaderHTML()

  %>
	<table>
	<tr>
		<td colspan="4" align="left"><% DrawSaveSuccessfulHTML(g_strSaveOperation) %><% ShowEmailSendingStatusMsg() %></td>
	</tr>
	
	<tr>
		<td class="heading_bug_list" colspan="4"><div class="float_left" style="margin: 0px 0 10px 0;"><%= g_strUserPageName %></div></td>
	</tr>
	<form method="post" id="edit_user_form" action="<%= g_strPageName %>" name="frm_edit_user" style="display:inline;">
	<tr>
		<td class="table_label">Users:</td>
		<td>
		<select size="1" id="existing_user_drop_list" class="ctrl_drop_list ctrl_drop_list_medium ctrl_float"  name="drp_existing_user" onchange="ResetDropList('existing_user_drop_list', 'existing_user_validation_msg');">
			<option value="0">(Select User)</option>
			<%= FillExistingUsersDropList() %>
		</select>
		<div class="ctrl_button_small ctrl_float button_spacer" style="margin: 2px 0 0 5px;"><a href="javascript:void();" onclick="ValidateDropList('existing_user_drop_list', 'existing_user_validation_msg', 'edit_user_form'); return false;">Edit</a></div>
		<div id="existing_user_validation_msg" class="validation_msg" style="display: none;">You forgot to select a user.</div>
		</td>
	</tr>

	<input type="hidden" name="hid_mode" value="<%= USERS_PAGE_MODE_EDIT %>">
	</form>

	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawUsersHTML()

	Dim strAccountIsActiveDefault
	Dim strFirstLoginDefault
	Dim strEmailWhenBugIsAssignedToMeDefault
	
	'setup some defaults
	if (g_iAccountIsActive = "") then	strAccountIsActiveDefault = " checked " end if
	
	if (g_iIsFirstLogin = "") then	strFirstLoginDefault = " checked " end if	

	if (g_iEmailWhenBugIsAssignedToMe = "") then strEmailWhenBugIsAssignedToMeDefault = " checked " end if	
	
	%>
	<form method="post" id="user_form" action="<%= g_strPageName %>?save_operation=1" name="frm_user" style="display:inline;">
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Login Details</td>
	</tr>		
	<tr>
		<td class="table_label">Username:</td>
		<td><input id="username_textbox" onkeydown="ResetTextboxBackground('username_textbox');" type="text" name="txt_login_username" value="<%= g_strLoginUsername %>" maxlength="32" class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %></td>
	</tr>
	<tr>
		<td class="table_label">Password:</td>
		<td><input type="text" id="password_textbox" onkeydown="ResetTextboxBackground('password_textbox');" name="txt_user_password" value="<%= g_strUserPassword %>" maxlength="32"  class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %></td>
	</tr>	
	<tr>
		<td class="item_list_table" style="padding-right: 10px; border-bottom: 0px;" align="right">Account type:</td>
		<td class="item_list_table" align="left" style="border-bottom: 0px;">
		<select size="1" id="account_type_droplist" onchange="ResetTextboxBackground('account_type_droplist');" class="ctrl_drop_list ctrl_drop_list_medium ctrl_float" name="drp_account_type">
			<option value="0">(Select Account Type)</option>
			<%= FillAccountTypeDropList(g_iAccountTypeID) %>
		</select><%= ICON_REQUIRED_FIELD %>
		<%= GetPopupHelpDB(24, OVERLIB_X_POS) %>
		</td>
	</tr>	
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>User Information</td>
	</tr>		
	
	<tr>
		<td class="table_label">First name:</td>
		<td class="item_list_table"><input type="text" id="firstname_textbox" onkeydown="ResetTextboxBackground('firstname_textbox');" name="txt_first_name" value="<%= g_strFirstName %>" maxlength="64" class="ctrl_textbox ctrl_textbox_medium"><%= ICON_REQUIRED_FIELD %></td>
	</tr>	
	
	<tr>
		<td class="table_label">Surname:</td>
		<td class="item_list_table" align="left"><input type="text" name="txt_last_name" value="<%= g_strLastName %>" maxlength="64" class="ctrl_textbox ctrl_textbox_medium"></td>
	</tr>	
	
	<tr>
		<td class="table_label">Initials:</td>
		<td class="item_list_table" align="left"><input type="text" id="initials_textbox" onkeydown="ResetTextboxBackground('initials_textbox');" name="txt_initials" value="<%= g_strInitials %>" maxlength="3" class="ctrl_textbox ctrl_textbox_small"><%= ICON_REQUIRED_FIELD %></td>
	</tr>		
	
	<tr>
		<td class="table_label">Email address:</td>
		<td class="item_list_table" align="left">
		<input type="text" name="txt_email_address" value="<%= g_strEmailAddress %>"  maxlength="128" class="ctrl_textbox ctrl_textbox_medium">
		<%= GetPopupHelpDB(22, OVERLIB_X_POS) %>
		</td>
		
	</tr>		
	<tr>
		<td class="table_label">Company:</td>
		<td class="item_list_table" align="left"><input type="text" name="txt_company" value="<%= g_strCompany %>" maxlength="255" class="ctrl_textbox ctrl_textbox_medium"></td>
	</tr>	
	
	<tr>
		<td class="table_label">Instant messenger:</td>
		<td class="item_list_table" align="left">
		<input type="text" name="txt_instant_messenger"" value="<%= g_InstantMessenger %>"  maxlength="255" class="ctrl_textbox ctrl_float" style="width: 190px; margin: 3px 5px 0 0;">
		<select size="1" id="im_type_drop_list" name="drp_im_type" class="ctrl_drop_list ctrl_float"  style="width: 93px;">
			<%= GetIMClientNames(g_iIMTypeID) %>
		</select>
		</td>
	</tr>		
	
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Account Options</td>
	</tr>		
	
	<!-- *** FEATURE ON-HOLD, FOR FUTURE IMPLEMENTATION ***
	<tr>
		<td class="item_list_table" style="padding-right: 10px;" align="right">Login IP Address:</td>
		<td class="item_list_table" align="left"><input type="text" name="txt_login_ip_address" value="<%= g_strLoginIpAddress %>" size="20" maxlength="128" class="control_textbox_medium"></td>
	</tr>		
	-->	
	<tr>
		<td class="table_label">Account expires:</td>
		<td class="item_list_table" align="left"><%= GetDropListDateControl(g_strLoginExpirationDate, "1/01/2020") %></td>
	</tr>			
	
	
	<tr>
		<td class="table_label">Interface style:</td>
		<td class="item_list_table" style="padding-right: 10px;" >
		<input type="radio" value="<%= UI_STYLE_BASIC %>" <%= IsChecked(g_iInterfaceStyle, UI_STYLE_BASIC) %>  name="rdo_interface_style" class="form_control_radio_button"><span class="form_control_radio_button_text">Basic</span>
		<input type="radio" value="<%= UI_STYLE_STANDARD %>" <%= IsChecked(g_iInterfaceStyle, UI_STYLE_STANDARD) %>  name="rdo_interface_style" class="form_control_radio_button"><span class="form_control_radio_button_text">Standard</span><%= GetPopupHelpDB(3, OVERLIB_X_POS) %>
		</td>
	</tr>		
	<tr>
		<td class="table_label">Pop-up help:</td>
		<td class="item_list_table" style="padding-right: 10px;" >
		<input type="radio" value="<%= POP_UP_HELP_NONE %>" <%= IsChecked(g_iPopupHelp, POP_UP_HELP_NONE) %>  name="rdo_popup_help" class="form_control_radio_button"><span class="form_control_radio_button_text">None</span>
		<input type="radio" value="<%= POP_UP_HELP_ADVANCED_ONLY %>" <%= IsChecked(g_iPopupHelp, POP_UP_HELP_ADVANCED_ONLY) %>  name="rdo_popup_help" class="form_control_radio_button"><span class="form_control_radio_button_text">Advanced only</span>
		<input type="radio" value="<%= POP_UP_HELP_ALL %>" <%= IsChecked(g_iPopupHelp, POP_UP_HELP_ALL) %>  name="rdo_popup_help" class="form_control_radio_button"><span class="form_control_radio_button_text">All</span>		
		<%= GetPopupHelpDB(13, OVERLIB_X_POS) %>
		</td>
	</tr>		
	

	<tr>
		<td class="table_label">After Logging a Bug:</td>
		<td class="item_list_table" style="padding-right: 10px;" >
		<input type="radio" value="<%= AFTER_LOGGING_BUG_LOG_BUG %>" <%= IsChecked(g_iActionAfterLoggingBug, AFTER_LOGGING_BUG_LOG_BUG) %>  name="rdo_action_after_logging_bug" class="form_control_radio_button"><span class="form_control_radio_button_text">Stay on log bug page</span>
		<input type="radio" value="<%= AFTER_LOGGING_BUG_GO_HOME %>" <%= IsChecked(g_iActionAfterLoggingBug, AFTER_LOGGING_BUG_GO_HOME) %>  name="rdo_action_after_logging_bug" class="form_control_radio_button"><span class="form_control_radio_button_text">Return to home page</span>
		<%= GetPopupHelpDB(34, OVERLIB_X_POS) %>
		</td>
	</tr>		
	
	<tr>
		<td class="table_label">&nbsp;</td>
		<td><input <%= strAccountIsActiveDefault %> type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iAccountIsActive) %> name="chk_account_is_active"><span class="checkbox_text">Account enabled</span> <%= GetPopupHelpDB(23, OVERLIB_X_POS) %></td>
	</tr>	
	<tr>
		<td></td>
		<td><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iIsIndependentQA) %> name="chk_is_independent_qa"><span class="checkbox_text">Independent QA</span> <%= GetPopupHelpDB(14, OVERLIB_X_POS) %></td>
	</tr>	
	
	<!-- *** feature placed on hold, to be implemented in future version ***
	<tr>
		<td class="item_list_table" style="padding-right: 10px;" align="right">IP-based Login Allowed:</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iIpBasedLoginAllowed) %> name="chk_ip_based_login_allowed"></td>
	</tr>		
	-->

	<!-- *** turned off for the time being, the feature has been turned off in the login mechanism too	
	<tr>
		<td>&nbsp;</td>
		<td><input <%= strFirstLoginDefault %> type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iIsFirstLogin) %> name="chk_is_first_login"><span class="checkbox_text">Offer video tutorials on first login</span> <%= GetPopupHelpDB(4, OVERLIB_X_POS) %></td>
	</tr>		
	
	<tr>
		<td class="item_list_table" style="padding-right: 10px;" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iMustLeaveTimeEstimate) %> name="chk_must_leave_time_estimate"><span class="checkbox_text">Must leave time estimate</span> <%= GetPopupHelpDB(30, OVERLIB_X_POS) %></td>
	</tr>	
	-->		


	
	<!-- *** removed as this was more like a bandaid fix for a real bug which was corrected in the end.
	<tr>
		<td class="item_list_table" style="padding-right: 10px;" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input <%= g_iUseAddCommentSafeMode %> type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iUseAddCommentSafeMode) %> name="chk_use_add_comment_safe_mode"><span class="checkbox_text">Use 'add comment' safe mode</span> <%= GetPopupHelpDB(29, OVERLIB_X_POS) %></td>
	</tr>
	-->		
	
	<tr>
		<td class="table_sub_headling" colspan="2"><br/><div class="section_divider"></div>Email Notification</td>
		<td class="item_list_table" style="border-bottom: 0px;"></td>
	</tr>		

	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iLimitEmailsPerDay) %> name="chk_limit_emails_per_day"><span class="checkbox_text">Limit emails per day <span class="note">(max. <%= MAX_EMAIL_NOTIFICATIONS_PER_DAY %> bug notifications)</span></span> <%= GetPopupHelpDB(12, OVERLIB_X_POS) %></td>
	</tr>	


	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iEmailWhenNewBugIsLogged) %> name="chk_email_when_new_bug_is_logged"><span class="checkbox_text">When a new bug is logged</span> <%= GetPopupHelpDB(8, OVERLIB_X_POS) %></td>
	</tr>	
	<tr>
		<td class="item_list_table" align="right">&nbsp;</td>
		<td class="item_list_table" align="left"><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iEmailWhenBugIsUpdated) %>  name="chk_email_when_bug_is_updated"><span class="checkbox_text">When a bug is updated</span> <%= GetPopupHelpDB(11, OVERLIB_X_POS) %></td>
	</tr>	
<tr>
	<td class="item_list_table" align="right">&nbsp;</td>
	<td class="item_list_table" align="left"><input type="checkbox" value="1" class="control_checkbox_alt_02" <%= SetCheckBox(g_iEmailWhenCommentIsAdded) %>  name="chk_email_when_comment_is_added"><span class="checkbox_text">When a comment is added against a bug</span> <%= GetPopupHelpDB(31, OVERLIB_X_POS) %></td>
</tr>	
		

	 <tr>
		<td class="table_sub_headling" colspan="2">

		
		<br/><div class="section_divider"></div><div class="float_left">Access to Projects</div>
				
		<span id="project_linking_validation_msg" class="alert_message float_clear" style="display: none; clear: both; float: left;">
		PANIC! Project associations haven't been set (<a href="<%= g_strPageName %>" onclick="DisableProjLinkChecking(); return false;" style="font-size: 9px;">swith off alert</a>).
		</span><!-- warning message -->
		
		</td>
	</tr>		
	
	<%= DrawBelongsToProjectList() %>
	
	<tr>
		<td></td>
		<td align="left" colspan="3" style="padding-top: 8px;">
		
		<% if (g_strPageMode = USERS_PAGE_MODE_EDIT) then %>
			<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateUserForm(); return false;">Update</a></div>
			<input type="hidden" value="<%= USERS_PAGE_MODE_UPDATE %>" name="hid_mode">
		
			<% if (g_iCanBeDeleted = INT_TRUE) then %>
				<div class="ctrl_button_small ctrl_float button_spacer button_icon_delete" style="margin-left: 0px;"><a href="javascript:void();" onclick="this.form.hid_mode.value=<%= USERS_PAGE_MODE_SOFT_DELETE %>; ConfirmUserSoftDelete(); return false;">Delete</a></div>
			<% else %>
				<div class="ctrl_button_small_disabled ctrl_float button_spacer button_icon_delete_disabled" title="Delete (Disabled)">Delete</div>
			<% end if %>
			
		<% else %>
		
			<div class="ctrl_button_small ctrl_float button_spacer" style="margin-left: 0px;"><a href="javascript:void();" onclick="ValidateUserForm(); return false;">Save</a></div>
			<input type="hidden" value="<%= USERS_PAGE_MODE_INSERT %>" name="hid_mode">
			<div class="ctrl_button_small_disabled ctrl_float button_spacer button_icon_delete_disabled" title="Delete (Disabled)">Delete</div>
			
		<% end if %>
		
		<a href="<%= g_strPageName %>?save_operation=0" class="image_button"" style="margin: 5px 0 0 7px; float: left;">Cancel</a>
		
		
		<input id="perform_proj_linking_check_hidden" name="hid_perform_proj_linking_check" type="hidden" value="1">
		</td>
	</tr>
	<input type="hidden" name="hid_user_id" value="<%= g_iSettingsUserID %>">
	</form>
	
	<script language=""JavaScript"">
		function UserHasProjectLinkage() 
	{
		var bRtnValue = false;
		<%= g_UserToProjectLinkageCheckJavascript %>
		return bRtnValue;
	}
	
	</script>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawUsersFooterHTML()
	
	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
%>