<!-- Upload File (Original code by Pedro Surna - www.yart.com.au) -->
<%

'------------------------------------------------------------------------------------------------------------------------
Dim m_form_size
Dim m_form_data
Dim attachment

Dim ttachment_file_name
Dim attachment_type

Dim file
Dim file_name
Dim file_object

Dim i
Dim strFileName
Dim gStrUploadDirectory

Dim strServerVar
Dim strImagePath
	
m_form_size = 0

'get the name of the directory the image is to be uploaded too.	
gStrUploadDirectory = Request.QueryString("upload_folder")

set file_object = Server.CreateObject("Scripting.FileSystemObject")

attachment = GetBinaryFormField("file", false)
attachment_type = GetAttachmentType("file")
attachment_type = GetAttachmentFileType(attachment_type)
attachment_file_name = GetAttachmentFileName(element_name)

strFileName = GetFileName(attachment_file_name)

strServerVar = Request.ServerVariables("PATH_TRANSLATED")
strImagePath = Left(strServerVar, (Len(strServerVar) - Len(GetPageName())))
		
file_name = strImagePath & gStrUploadDirectory & strFileName 'adjusted

set file = file_object.CreateTextFile(file_name, true) 'create a file to store the uploaded file

For i = 1 to LenB(attachment)
  file.Write Chr(AscB(MidB(attachment, i, 1)))
Next

file.Close

set file = Nothing
set file_object = Nothing

'return back to calling page
Response.Redirect Request.QueryString("rtn_page")
 
'------------------------------------------------------------------------------------------------------------------------  
function BinaryStringToTextString(str)

  Dim bin_str, count, next_char, str_len

  str_len = LenB(str)

  for count = 1 to str_len
    next_char = MidB(str, count, 1)
	  bin_str = bin_str & Chr(AscB(next_char))
  next

  BinaryStringToTextString = bin_str

end function
'------------------------------------------------------------------------------------------------------------------------
function FileName(complete_file_name)

  Dim file_name, pos

  complete_file_name = Replace(complete_file_name, "/", "\")

  pos = InStrRev(complete_file_name, "\")

  if pos <> 0 then
    file_name = Right(complete_file_name, Len(complete_file_name) - pos)
  else
    file_name = complete_file_name
  end if

  FileName = file_name

end function
'------------------------------------------------------------------------------------------------------------------------
function GetAttachmentFileName(field_name)
  
  Dim file_name, pos_file_name_end, pos_file_name_start, pos_field_name

  SetFormData

  pos_field_name = InStrB(m_form_data, TextStringToBinaryString(field_name))

  if pos_field_name <> 0 then
  
    'the start of the first charcater after the pharse 'Content-Type: '
    pos_file_name_start = InStrB(pos_field_name, m_form_data, TextStringToBinaryString("filename=")) + LenB(TextStringToBinaryString("filename="))
    pos_file_name_end = InStrB(pos_file_name_start, m_form_data, ChrB(13))
    
    file_name = MidB(m_form_data, pos_file_name_start, pos_file_name_end - pos_file_name_start)
    file_name = BinaryStringToTextString(file_name)
    file_name = Mid(file_name, 2, Len(file_name) - 2)

  end if

  GetAttachmentFileName = file_name

end function
'------------------------------------------------------------------------------------------------------------------------
function GetAttachmentFileType(attachment_type)
  
  Dim file_type

  Select Case attachment_type
  
    Case "application/msaccess"         file_type = "mdb"
    Case "application/msword"           file_type = "doc"
    case "application/octet-stream"     file_type = "exe"
    Case "application/pdf"              file_type = "pdf"
    Case "application/vnd.ms-excel"     file_type = "xls"
    Case "application/x-zip-compressed" file_type = "zip"
    Case "image/bmp"                    file_type = "bmp"
    Case "image/gif"                    file_type = "gif"
    Case "image/pjpeg"                  file_type = "jpg"
    Case "message/rfc822"               file_type = "eml"
    Case "text/html"                    file_type = "htm"
    Case "text/plain"                   file_type = "txt"
    Case "audio/mp3"                    file_type = "mp3"

	  Case Else response.Write "error GetAttachmentFileType unknown " & attachment_type
  
  End Select
      
  GetAttachmentFileType = file_type
  
end function
'------------------------------------------------------------------------------------------------------------------------
function GetAttachmentType(field_name)
  
  Dim attachment_type, pos_content_type_end, pos_content_type_start, pos_field_name

  SetFormData

  pos_field_name = InStrB(m_form_data, TextStringToBinaryString(field_name))

  if pos_field_name <> 0 then
  
    'the start of the first charcater after the pharse 'Content-Type: '
    pos_content_type_start = InStrB(pos_field_name, m_form_data, TextStringToBinaryString("Content-Type: ")) + 14
    pos_content_type_end = InStrB(pos_content_type_start, m_form_data, ChrB(13))
    
    attachment_type = MidB(m_form_data, pos_content_type_start, pos_content_type_end - pos_content_type_start)
    attachment_type = BinaryStringToTextString(attachment_type)

  end if

  GetAttachmentType = attachment_type

end function
'------------------------------------------------------------------------------------------------------------------------
function GetBinaryFormField(field_name, remove_trailing_line_feed)

  Dim bnCRLF, divider, field_end, field_start, form_field, pos_field_name
  
  if remove_trailing_line_feed then
    remove_trailing_line_feed = 2
  else
    remove_trailing_line_feed = 0
  end if

  SetFormData

  pos_field_name = InStrB(m_form_data, TextStringToBinaryString("""" & field_name & """"))

  if pos_field_name <> 0 then
  
    while pos_field_name <> 0

      bnCRLF = chrB(13) & chrB(10)
      divider = LeftB(m_form_data, InStrB(m_form_data, bnCRLF) - 1)

      field_start = InStrB(pos_field_name, m_form_data, bnCRLF & bnCRLF) + 4
      field_end = InStrB(field_start + 1, m_form_data, divider) - field_start
      
      if LenB(form_field) > 0 then
        form_field = form_field & ChrB(Asc(vbTab))
      end if
      
      form_field = form_field & MidB(m_form_data, field_start, field_end - remove_trailing_line_feed)
    
      pos_field_name = InStrB(pos_field_name + 1, m_form_data, TextStringToBinaryString("""" & field_name & """"))
      
    wend

  end if

  GetBinaryFormField = form_field

end function
'------------------------------------------------------------------------------------------------------------------------
function GetFormVariableMultiPart(name)

  Dim variable

  variable = GetBinaryFormField(name, true)
  variable = BinaryStringToTextString(variable)

  if VarType(variable) = 0 then
    variable = ""
  end if

  GetFormVariableMultiPart = variable

end function
'------------------------------------------------------------------------------------------------------------------------
function RequestForm(variable_name)

  Dim value

  if Len(variable_name) > 0 then
    value = GetFormVariableMultiPart(variable_name)
  else
    value = ""
  end if
  
  RequestForm = value
  
end function
'------------------------------------------------------------------------------------------------------------------------
sub SetFormData

  if m_form_size = 0 then
    m_form_size = Request.TotalBytes
    m_form_data = Request.BinaryRead(m_form_size)
  end if

end sub
'------------------------------------------------------------------------------------------------------------------------
function TextStringToBinaryString(str)

  Dim bin_str, count, next_char, str_len

  str_len = Len(str)

  'turn str into a binary string
  for count = 1 to str_len
    next_char = Mid(str, count, 1)
	  bin_str = bin_str & ChrB(AscB(next_char))
  next

  TextStringToBinaryString = bin_str

end function
'------------------------------------------------------------------------------------------------------------------------
function WriteBinaryDataToFile(name)

  Dim objFSO, objFSOFile
  Dim lngLoop
  Dim attachment, attachment_type, attachment_file_name, file, file_object, path
  
  attachment = GetBinaryFormField(name, false)
  attachment_type = GetAttachmentType(name)
  attachment_file_name = GetAttachmentFileName(name)

  Set objFSO = Server.CreateObject("Scripting.FileSystemObject")

  path = Request.ServerVariables("APPL_PHYSICAL_PATH")
  file = FileName(attachment_file_name)
  
  if LenB(attachment) > 10 then
    
    if name = "word" then
      path = path & "files\" & file
    elseif name = "image" then
      path = path & "images\" & file
    end if

    Set objFSOFile = objFSO.CreateTextFile(path)
          
    For lngLoop = 1 to LenB(attachment)
	    objFSOFile.Write Chr(AscB(MidB(attachment, lngLoop, 1)))
    Next
    
    objFSOFile.Close
  else
  
    file = ""
    
  end if

  	
  Set objFSO = Nothing
  Set objFSOFile = Nothing	
  WriteBinaryDataToFile = file

end function
'------------------------------------------------------------------------------------------------------------------------  
Function GetFileName(strInputPathAndFileName)

	Dim strRtnValue, strArrSplitPathAndFileName

	strArrSplitPathAndFileName = Split(strInputPathAndFileName, "\")
	
	strRtnValue = strArrSplitPathAndFileName(UBound(strArrSplitPathAndFileName))
			
	GetFileName = strRtnValue

End Function
'------------------------------------------------------------------------------------------------------------------------
%>