<!-- User Manual (08072007) -->
<% 


Dim g_strPageMode
Dim g_strOnlineHelpTitle

'--------------------------------------------------------------------------------------------------------
Function UserManualPageStartUp()

	g_strPageMode = Request.QueryString("page_mode")

End Function
'--------------------------------------------------------------------------------------------------------
Function SetOnlineHelplPageMode()
	
	Select Case g_strPageMode
		
		Case PAGE_MODE_ICON_LEGEND
			g_strOnlineHelpTitle = "Icon Legend:"
			DrawOnlineHelpHeaderHTML()
			DrawIconLegendHTMLVer2()
			DrawSettingsFooterHTML() 
		
		Case Else
			g_strOnlineHelpTitle = "Help"
			DrawOnlineHelpHeaderHTML()
			DrawOnlineHelpHTML()
			DrawSettingsFooterHTML() 
	
	End Select

End Function

'--------------------------------------------------------------------------------------------------------
Function DrawOnlineHelpHeaderHTML()

  %>
	<table width="100%">
	<tr>
		<td class="heading_bug_list" colspan="4" align="left"><%= g_strOnlineHelpTitle %></td>
	</tr>
	<tr>
		<td colspan="4">&nbsp;</td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawTutorialVideoListHTML()
	
	Dim objRecordSet
	Dim strSqlQuery
	
	strSqlQuery = "SELECT * FROM tbl_tutorial_videos ORDER BY display_order;"
		
	Set objRecordSet = GetRecordSet(strSqlQuery)
	
	%>
	<div class="spacer_05x05"></div>
	<table class="tbl_standard">
	<tr>
		<td></td>
		<td class="cell_tutorial_video" style="background-color: #e9e9e9;">Title</td>
		<td class="cell_tutorial_video" style="background-color: #e9e9e9;"><%= ICON_FLASH %> Streaming <span class="note">(Flash)</span></td>
		<td class="cell_tutorial_video" style="background-color: #e9e9e9;"><%= ICON_VIDEO %> Download<span class="note"> (in Microsoft WMV format)</span></td>
	</tr>
	<%
	
	Do Until objRecordSet.EOF
		%>
		<tr>
			<td class="cell_tutorial_video"><%= objRecordSet("display_order") %></td>
			<td class="cell_tutorial_video"><%= objRecordSet("video_title") %></td>
			<td class="cell_tutorial_video"><a onclick="var popup1=window.open('video_streaming_player.asp?id_video=<%= objRecordSet("id_training_video") %>&streaming_url=<%= g_strSettingVideoStreamingURL %>','popup1','width=2,height=2,toolbar=no,menubar=no,resizable=1,menubar=no,status=no,scrollbars=no,screenX=100,screenY=100,top=100,left=100'); popup1.focus(); return false" href="video_streaming_player.asp" title="<%= objRecordSet("video_title") %>" target="_blank">Watch</a> <span class="note">(<%= objRecordSet("video_duration") %>)</span></td>
			<td class="cell_tutorial_video"><a href="<%= g_strSettingVideoDownloadURL & objRecordSet("download_file") %>"><%= objRecordSet("download_file") %></a> <span class="note">(<%= objRecordSet("file_size") %>)</span></td>
		</tr>
		<%  
		objRecordSet.MoveNext
	Loop
	
	%></table><%
	
	objRecordSet.Close
	Set objRecordSet = Nothing
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawOnlineHelpHTML()

  %>
	<tr>
		<td class="hyperlink_list" colspan="4" align="left">
		<!-- <b>Tutorial Videos</b> <%= GetPopupHelpDB(26, OVERLIB_X_POS) %> -->
		<% 'DrawTutorialVideoListHTML() %>

		<%= ICON_PDF %> <a href="<%= GetSystemSetting(8) %>" target="_blank">BugWeb User Manual</a> <span class="note">(8 pages)</span> <%= GetPopupHelpDB(27, OVERLIB_X_POS) %>
		
		<div class="medium_spacer"></div>
		<%= ICON_PDF %> <a href="<%= GetSystemSetting(9) %>" target="_blank">Reporting Bugs: a Quick Guide</a> <span class="note">(2 pages)</span> <%= GetPopupHelpDB(1, OVERLIB_X_POS) %>
		
		<div class="medium_spacer"></div>
		<%= ICON_PDF %> <a href="<%= GetSystemSetting(38) %>" target="_blank">GNU General Public License</a> <span class="note">(11 pages)</span>
		
		<div class="medium_spacer"></div>
		<%= ICON_PDF %> <a href="<%= GetSystemSetting(39) %>" target="_blank">BugWeb Installation Guide</a> <span class="note">(7 pages)</span>
		
		<div class="large_spacer"></div>
		<%= ICON_DOWNLOAD %> Download <a href="<%= ADOBE_PDF_READER_LINK %>" target="_blank">Adobe Acrobat Reader</a> <span class="note">(required for PDFs).</span>
		
		<div class="medium_spacer"></div>
		For further help, contact support via <a href="mailto:<%= BUGWEB_TECH_SUPPORT_EMAIL %>?subject=BugWeb: tech support/bug report"><%= BUGWEB_TECH_SUPPORT_EMAIL %></a>.
		</td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawIconLegendHTMLVer2()
	
  %>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_REQUIRED_FIELD %> Required field</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_HOVER_OVER_HELP %> Hover-over help</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_PDF %> PDF file download</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_VIDEO_ALT_02 %> Windows AVI video file</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_EXPANDING_ZONE_OPEN %> Expanding zone (opened)</td>
	</tr>

	
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_BUG_OPEN %> Open bug</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_BUG_ON_HOLD %> Bug placed on-hold</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_BUG_CLOSED %> Closed bug</td>
	</tr>		
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_PRIORITY_HIGH %> High priority bug</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_PRIORITY_NORMAL %> Normal bug priority</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_PRIORITY_LOW %> Low priority bug</td>
	</tr>		
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_TYPE_BUG %> Logged item is a bug</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_TYPE_FEATURE_REQUEST %> Logged item is a feature request</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_TYPE_GENERAL %> Logged item is 'general'.</td>
	</tr>			
	
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_EXPANDING_ZONE_CLOSE %> Expanding zone (closed)</td>
	</tr>
	<tr>
		<td class="item_list_table" colspan="4"><%= ICON_PROJECT_ACTIVE %> Active project</td>
	</tr>
	<tr>
		<td class="item_list_table" style="border-bottom: 0px;" colspan="4"><%= ICON_PROJECT_INACTIVE %> Inactive project</td>
	</tr>
	<% 
	
End Function
'--------------------------------------------------------------------------------------------------------
Function DrawSettingsFooterHTML()

	%>
	</table>
	<%  

End Function
'--------------------------------------------------------------------------------------------------------
Function DrawIconLegendHTML()
	
	Dim strArrListOfFiles
	Dim iCounter
	Dim strWordsToStripFromPath
	Dim strFolderHoldingFiles
	
	Dim strNameOfCurrentFile
	Dim strServerVar
	Dim strPathToLookIn
	
	Dim strFileExtension
	
	strFolderHoldingFiles = "images\"
	strFileExtension = ".gif"
	
	strServerVar = Request.ServerVariables("PATH_TRANSLATED")
	strPathToLookIn = Left(strServerVar, (Len(strServerVar) - Len(GetPageName()))) & strFolderHoldingFiles

	strArrListOfFiles = GenerateFileList(strPathToLookIn)
	
	%><tr><td class="hyperlink_list" colspan="4" align="left"><%  
	
	For iCounter = 0 To UBound(strArrListOfFiles)

		strNameOfCurrentFile = strArrListOfFiles(iCounter)	
		'only add files to the list which are on the acceptable file extensions list
		if (NOT InStr(LCase(strNameOfCurrentFile), LCase(strFileExtension)) = 0) then
		
			'filter out images which arent icons
			if (NOT InStr(LCase(strNameOfCurrentFile), "icon_") = 0) then
				response.write GetIconLegendItem(strNameOfCurrentFile)
			end if
			
		end if
			
	Next
	
	%></tr></td><%
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetIconLegendItem(strInputIconFileName)
	
	Dim strRtnValue
	Dim strIconDescription
	
	strIconDescription = Replace(strInputIconFileName, "icon_", "")
	strIconDescription = Replace(strIconDescription, ".gif", "")
	'strIconDescription = Replace(strIconDescription, "alt_01", " ")
	'strIconDescription = Replace(strIconDescription, "alt_02", " ")
	'strIconDescription = Replace(strIconDescription, "alt_03", " ")
	'strIconDescription = Replace(strIconDescription, "alt_04", " ")			
	'strIconDescription = Replace(strIconDescription, "alt_05", " ")			
	strIconDescription = Replace(strIconDescription, "_", " ")
	strIconDescription = TCase(strIconDescription)
	
	strRtnValue = "<img src=""images/" & strInputIconFileName & """ align=""absmiddle"" border=""0"">&nbsp;" & strIconDescription & "<br>" & vbCrLf
	
	GetIconLegendItem = strRtnValue

End Function
'--------------------------------------------------------------------------------------------------------
Function GenerateFileList(strInputDirPath)
		
	'get list of files
	Dim FileSysObj
	Dim FolderObj
	Dim tempObj
	
	Dim strSelected
	Dim iNumOfFiles
	Dim iCounter
	
	Dim strArrRtnValue
	
	iCounter = 0
	
	Set FileSysObj = Server.CreateObject("Scripting.FileSystemObject")
	Set FolderObj = FileSysObj.GetFolder(strInputDirPath)

	For Each tempObj In FolderObj.files
		iNumOfFiles = iNumOfFiles + 1
	Next
	
	ReDim strArrRtnValue(iNumOfFiles-1) 'account for zero element in array
	 
	For Each tempObj In FolderObj.files
		strArrRtnValue(iCounter) = tempObj.Name
		iCounter = iCounter + 1
	Next
	
	Set FolderObj = nothing
	Set FileSysObj = nothing
	
	GenerateFileList = strArrRtnValue
	
End Function
'--------------------------------------------------------------------------------------------------------
%>