<% 'Response.expires = 0 'turns off caching %>
<% 
'-------------------------------------------------------------------------------------------------------

Dim g_iUserID
Dim g_iSecurityAccessStatus
Dim g_strSecuritySystemPageName

'-------------------------------------------------------------------------------------------------------

SecuritySystemPageStartUp()

g_iSecurityAccessStatus = PerformSecurityCheck()

ProcessSecurityCheck()

'-------------------------------------------------------------------------------------------------------
Function SecuritySystemPageStartUp()

	g_strSecuritySystemPageName = GetPageName()
																			 
	ReadSecurityCookie()																			 
																			 
End Function
'-------------------------------------------------------------------------------------------------------
Function ProcessSecurityCheck()

	'dont do the security check on the login page (the user always needs unabaited access to this page).
	if (NOT GetPageName() = LOGIN_PAGE) then

		'show person access denied page if they dont have security clearance.
		if (g_iSecurityAccessStatus = SECURITY_ACCESS_INITIAL_ENTRY) then
			Response.Redirect "login.asp"
		elseif (g_iSecurityAccessStatus = SECURITY_ACCESS_BAD) then
			DrawAccessDeniedHTML()
			response.end
		end if
	
	end if

End Function
'-------------------------------------------------------------------------------------------------------
Function ReadSecurityCookie()

	'to read out the security cookie.
	g_iUserID = Request.Cookies("user_id")

End Function
'-------------------------------------------------------------------------------------------------------
Function PerformSecurityCheck()

	Dim iSecurityCheckStatus

	if (Trim(g_iUserID) = "") then
		iSecurityCheckStatus = SECURITY_ACCESS_BAD
	else
		iSecurityCheckStatus = SECURITY_ACCESS_GOOD
	end if

	PerformSecurityCheck = iSecurityCheckStatus

End Function
'-------------------------------------------------------------------------------------------------------
Function DrawAccessDeniedHTML()

	Dim strIconExclaim
	Dim strIconNote
	
	strIconExclaim = "<img src=""images_icons/icon_alert.png"" alt=""Alert"" />"
	strIconNote = "<img src=""images_icons/icon_note.png"" alt=""Note"" />"

	%>
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
	
	<html>
	<head>
		<title>Can't access this page</title>
		<style>
		td { font-family: Verdana; font-size: 15px; color: #262626; }
		.major_heading {  font-family: Verdana;  font-size: 20px;  font-weight: bold;  color: #ed8223; margin: 0 0 10px 0; }
		.sub_heading {  font-family: Verdana; font-size: 18px; font-weight: normal; color: #ed8223; }
		.icon_standard { margin: 0 4px 0 0; vertical-align: middle; }
		</style>
		
		<script>
		function VerticallyCentreMsgDialogue()
		{
			var iPaddingAmount;
			iPaddingAmount = (document.documentElement.clientHeight / 2) - 57;
			document.getElementById('verticle_centering').style.paddingBottom = iPaddingAmount;
		}
		</script>
		
	</head>
	
	<body topmargin="0" leftmargin="0" onload="VerticallyCentreMsgDialogue();">

	<div id="verticle_centering" style="padding-bottom: 20px;"></div>
	<table width="100%" height="100%">
	<tr>
		<td align="center">

	<table width="370">
	<tr>
		<td><img src="images_layout/dialogue_corner_top_left.png" alt="" /></td>
		<td style="border-top: solid 1px #A7A7A7;">&nbsp;</td>
		<td><img src="images_layout/dialogue_corner_top_right.png" alt="" /></td>
	</tr>
	<tr>
		<td style="border-left: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="padding-bottom: 10px;" align="left"><img src="images_icons/icon_alert.png" class="icon_standard" alt="Alert" /> <span class="major_heading">Can't access this page</span></td>
		<td style="border-right: solid 1px #A7A7A7;">&nbsp;</td>
	</tr>		
	<tr>
		<td style="border-left: solid 1px #A7A7A7;">&nbsp;</td>
		<td style="text-align: left;">
		You must be logged in (and also have the correct access privileges) to view this page.
		<div style="padding-top: 20px;"></div>
		<img src="images_icons/icon_note.png" class="icon_standard" alt="Note" /> You may have problems logging in if you have cookies turned off in your browser.
		<br><br>
		Go to the <a href="login.asp">Login</a> page.
		</td>
		<td style="border-right: solid 1px #A7A7A7;">&nbsp;</td>
	</tr>		
	<tr>
		<td><img src="images_layout/dialogue_corner_bottom_left.png" alt="" /></td>
		<td style="border-bottom: solid 1px #A7A7A7;">&nbsp;</td>
		<td><img src="images_layout/dialogue_corner_bottom_right.png" alt="" /></td>
	</tr>
	</table>
	
		</td>
	</tr>
	</table>
	
	</body>
	</html>
	<%
	
End Function
'-------------------------------------------------------------------------------------------------------
%>