<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">

<!--#include file="include\db_connection.asp"-->
<!--#include file="include\global_constants.inc"-->
<!--#include file="include\global_custom_functions.inc"-->

<% 

Dim g_strStreamingVideoFileName
Dim g_strDownloadVideoFileName
Dim g_strVideoTitle

Dim g_strStreamingURL

VideoStreamingPlayerStartUp()

'--------------------------------------------------------------------------------------------------------
Function VideoStreamingPlayerStartUp()

	Dim strVideoID
	
	strVideoID = Request.QueryString("id_video")
	g_strStreamingURL = Request.QueryString("streaming_url")
	
	GetVideoDetails(strVideoID)
	
End Function
'--------------------------------------------------------------------------------------------------------
Function GetVideoDetails(strInputVideoID)

 	Dim strSqlQuery
	Dim objRecordSet
	
	strSqlQuery = "SELECT * FROM tbl_tutorial_videos WHERE id_training_video = " & strInputVideoID
	Set objRecordSet = GetRecordSet(strSqlQuery)

	if (objRecordSet.EOF) then
		response.write "<b>Error:</b> the system could not determine what video file should be played."
		response.end
	else
		g_strStreamingVideoFileName = objRecordSet("streaming_file")
		g_strVideoTitle = "<span class=""video_title"">" & objRecordSet("video_title") & "</span> " & objRecordSet("video_duration")
		
		'adjust for javascript escape-sequence paths
		g_strStreamingVideoFileName = Replace(g_strStreamingVideoFileName, "\", "\\")
		g_strStreamingVideoFileName = Replace(g_strStreamingVideoFileName, "/", "\\")
	end if
		
	objRecordSet.Close
	Set objRecordSet = Nothing

End Function
'--------------------------------------------------------------------------------------------------------
%>

<head>

	<title>Video Streaming Player</title>

	<style type="text/css">
	body	{
		font-family: Verdana;
		font-size: 10px;
		color: #767676;
	}
	
	td {
		font-family: Verdana;
		font-size: 10px;
		color: #767676;
	}
	
		
	.video_title {
		font-family: Verdana;
		font-size: 14px;
		font-weight: bold;
		color: #767676;
		padding-left: 15px;
	}
	
	a:link {
	  color: #0048c0;	
	  text-decoration: none;
	  border-bottom: 1px dotted #0048c0;
	}
	
	a:visited {
	  color: #0048c0;	
	  text-decoration: none;
	  border-bottom: 1px dotted #0048c0;
	}
	
	a:hover {
	  color: #767676;
	  text-decoration: none; 
	  border-bottom: 1px dotted #767676; 
	  background-color: #fff282;
	}	
	
	.tbl_information {
		margin-top: 5px;
		width: 800px;
		border-collapse: collapse;
	}
	
	.cell_information {
		padding-top: 2px;
		padding-bottom: 2px;
		padding-left: 2px;
		padding-right: 2px;		
		border: 1px solid #cccccc;			
		text-align: left;			
	}
	
	.icon_standard {
		vertical-align: middle;
	}
	
	a.invisible_hyperlink:link, a.invisible_hyperlink:visited, a.invisible_hyperlink:active, a.invisible_hyperlink:hover {
  	text-decoration: none;
	  border: none;
	}	
	
	#close_button a {
	  font-family: Verdana;
	  font-size: 10px;
	  font-weight: normal;
	  padding-left: 3px;
		padding-right: 3px;
		padding-top: 4px;
		padding-bottom: 4px;
	  display: block;
		color: #FFFFFF;
		text-align: center;				
		background-color: #afafaf;
	}
	
	#close_button a:hover {
	  background-color: #6BA1C5;
	}	
	</style>
	
	<script language='javascript'>
	var NS = (navigator.appName=="Netscape")?true:false;
	
	function FitVideo() 
	{
		iWidth = 740; 
		iHeight = 560;
		window.resizeBy(iWidth, iHeight);
		centerWindow();
		self.focus();
	 }
	
	function centerWindow() 
	{
		width = (NS) ? window.outerWidth-78 : document.body.clientWidth-4;
		height = (NS) ? window.outerHeight-70 : document.body.clientHeight-21;
		var w = (screen.width - width)/2
		var h = (screen.height - height)/2
		self.moveTo(w, h)
	}
	</script>


</head>

<body onload="FitVideo();">

<%= g_strVideoTitle %>
<center>
	<div id="video_container" style="padding-top: 3px;"></div>
	<script type="text/javascript" src="mediaplayer.js"></script>
	
	<script type="text/javascript">
		var s1 = new SWFObject("mediaplayer.swf","mediaplayer","800","600","8");
		s1.addParam("allowfullscreen","true");
		s1.addVariable("width","800");
		s1.addVariable("height","600");
		s1.addVariable("autostart","true");
		s1.addVariable("file","<%= g_strStreamingURL & g_strStreamingVideoFileName %>");
		s1.write("video_container");
	</script>
	
	<table cellspacing="0" cellpadding="0" class="tbl_information">
	<tr>
		<td><a href="http://www.macromedia.com/go/getflashplayer" target="_blank">Adobe Flash Player</a> is required to watch this video.</td>
		<td style="border: 1px solid #cccccc;"><div id="close_button"><a onclick="javascript:window.close()" href="video_streaming_player.asp" class="invisible_hyperlink" title="Close video streaming window">Close</a></div></td>
	</tr>
	</table>
	
</center>
	
</body>
</html>